﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        string data_recibida;
        bool bitRTS, bitDTR;
                
        public Form1()
        {
            InitializeComponent();
            serialPort1.DataReceived +=new SerialDataReceivedEventHandler(Recibir);        
        }

        private void Recibir(object sender, System.IO.Ports.SerialDataReceivedEventArgs e) 
        {
            data_recibida = serialPort1.ReadExisting();
            this.Invoke(new EventHandler(Actualizar));            
        }

        private void Actualizar(object a, EventArgs e)
        {
            txtRecibido.Text = txtRecibido.Text + data_recibida;            
        }
                
        private void Form1_Load(object sender, EventArgs e)
        {                            
            cmdDTR.Enabled = false;
            cmdRTS.Enabled = false;
            bitDTR = true;
            bitRTS = true;
            CheckForIllegalCrossThreadCalls = false;            
        }

        private void cmdAbrir_Click(object sender, EventArgs e)
        {          
            try 
            { 
            serialPort1.Open(); this.Text = "Puerto Serial : Puerto abierto";
            cmdAbrir.Enabled = false;
            txtEnviar.Focus();
            cmdDTR.Enabled = true;
            cmdRTS.Enabled = true;
            ledCD.BackColor = Color.Firebrick;
            ledCTS.BackColor = Color.Firebrick;
            ledDSR.BackColor = Color.Firebrick;
            }
            catch (Exception) 
            { 
            this.Text = "Puerto Serial : No se pudo abrir el puerto"; 
            cmdAbrir.Enabled = true;
            txtEnviar.Focus();
            cmdDTR.Enabled = false;
            cmdRTS.Enabled = false;
            ledCD.BackColor = Color.DarkGray;
            ledCTS.BackColor = Color.DarkGray;
            ledDSR.BackColor = Color.DarkGray;
            }
           // this.Text = serialPort1.CDHolding.ToString() + serialPort1.DsrHolding.ToString() + serialPort1.CtsHolding.ToString();
           // this.Text = serialPort1.DtrEnable.ToString() + serialPort1.RtsEnable.ToString();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            serialPort1.Close(); 
        }

        private void cmdEnviar_Click(object sender, EventArgs e)
        {
            string data_temp;

            if (serialPort1.IsOpen) {
                data_temp = txtEnviar.Text;
                txtEnviar.Text = txtEnviar.Text + System.Convert.ToChar(13);
                serialPort1.Write(txtEnviar.Text);
                txtEnviar.Text = data_temp;
                txtEnviar.Focus();
            }
        }

        private void cmdRTS_Click(object sender, EventArgs e)
        {
            if (bitRTS) 
            {
                cmdRTS.Text = "Apagar RTS";
                bitRTS = false;
            }
            else 
            {
                cmdRTS.Text = "Enviar RTS";
                bitRTS = true;
            }
            serialPort1.RtsEnable = bitRTS;
         //   this.Text = serialPort1.CDHolding.ToString() + serialPort1.DsrHolding.ToString() + serialPort1.CtsHolding.ToString();
        }


        private void cmdDTR_Click(object sender, EventArgs e)
        {
            if (bitDTR)
            {
                cmdDTR.Text = "Apagar DTR";
                bitDTR = false;
            }
            else
            {
                cmdDTR.Text = "Enviar DTR";
                bitDTR = true;
            }
            serialPort1.DtrEnable = bitDTR;
         //   this.Text = serialPort1.CDHolding.ToString() + serialPort1.DsrHolding.ToString() + serialPort1.CtsHolding.ToString();
        }

        private void cmdLimpiarEnviado_Click(object sender, EventArgs e)
        {
            txtEnviar.Text = "";
            txtEnviar.Focus();
        }

        private void cmdLimpiar_Click(object sender, EventArgs e)
        {
            txtRecibido.Text = "";
            txtEnviar.Focus();
        }

        private void serialPort1_PinChanged(object sender, SerialPinChangedEventArgs e)
        {
            switch (e.EventType) 
            {
              case SerialPinChange.CDChanged:

                  if (serialPort1.CDHolding)
                      ledCD.BackColor = Color.Firebrick;
                  else
                      ledCD.BackColor = Color.DarkGray;
                  break;

              case SerialPinChange.CtsChanged:
                  if (serialPort1.CtsHolding)
                      ledCTS.BackColor = Color.Firebrick;
                  else
                      ledCTS.BackColor = Color.DarkGray;
                  break;

              case SerialPinChange.DsrChanged:
                  if (serialPort1.DsrHolding)
                      ledDSR.BackColor = Color.Firebrick;
                  else
                      ledDSR.BackColor = Color.DarkGray;
                  break;
            }

        } 
                
    }
}